<?php

$USAObj = new user_auth();

class user_auth {
    public $db;
    public $conn;
    public $lang;
    public $dateTime;
    public function __construct() {
        $this->db = new MO();
        $this->conn = $this->db->connect();
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    //****************************************** CHECK ******************************************
    //****************************************** CHECK ******************************************
    //****************************************** CHECK ******************************************
    //****************************************** CHECK ******************************************
    //****************************************** CHECK ******************************************
    public function checkIfMobileExist($mobile) {
        $sql = "SELECT * 
                FROM users 
                WHERE mobile = :mobile";
        $stmt = $this->db->connect()->prepare($sql);
        $stmt->bindParam(':mobile', $mobile, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    public function checkIfEmailExist($a, $email) {
        if ($a == 0) {
            $sql = "SELECT * FROM `users` WHERE `email` = :email";
            $query = $this->conn->prepare($sql);
            $query->bindParam(':email', $email, PDO::PARAM_STR);
            $query->execute();
            return $query->fetch(PDO::FETCH_ASSOC);
        } elseif ($a == 1) {
            $deleteSql = "DELETE FROM `verification` WHERE `email` = :email";
            $deleteQuery = $this->conn->prepare($deleteSql);
            $deleteQuery->bindParam(':email', $email, PDO::PARAM_STR);
            $deleteQuery->execute();
        } elseif ($a == 2) {
            $sql = "SELECT u.email, ua.id 
                    FROM `users` u 
                    LEFT JOIN `user_auth` ua ON u.id = ua.user_id AND ua.page_type = 'user'
                    WHERE u.`email` = :email";
            $query = $this->conn->prepare($sql);
            $query->bindParam(':email', $email, PDO::PARAM_STR);
            $query->execute();
            return $query->fetch(PDO::FETCH_ASSOC);
        }
    }

    public function generatePasswordResetToken() {
        $code = random_int(100000, 999999); // Generate a random number between 100000 and 999999 (inclusive)
        return (string) $code; // Convert the integer to string
    }
    public function storePasswordResetToken($email, $code) {
        $sql = "INSERT INTO verification SET code = :code  , email = :email ";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':code', $code, PDO::PARAM_STR);
        $query->bindParam(':email', $email, PDO::PARAM_STR);
        $query->execute();
        return $query->rowCount() > 0;
    }
    //****************************************** LOGIN ******************************************
    //****************************************** LOGIN ******************************************
    //****************************************** LOGIN ******************************************
    //****************************************** LOGIN ******************************************
    //****************************************** LOGIN ******************************************
    public function checkPassword($email, $password) {
        $sql = "SELECT `id` FROM `users` ";
        $sql .= " WHERE  `email` = :email AND `password` = :password ";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':email', $email, PDO::PARAM_STR);
        $query->bindParam(':password', $password, PDO::PARAM_STR);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }
    public function AddNewLogin($user_id) {
        $sql = "INSERT INTO users_login
                SET 
                    user_id = :user_id,
                    login_date = :login_date";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':login_date', $this->dateTime, PDO::PARAM_STR);
        $stmt->execute();
    }

    public function getUserDetailsInfo($cond, $type) {
        $sql = "SELECT
                    id,
                    user_name, 
                    active, 
                    mobile, 
                    lat, 
                    lon,   
                    code,
                    password
                FROM users
                WHERE  " .
            ($type == 'register' ? "id = :id" : "mobile = :mobile");
        $stmt = $this->conn->prepare($sql);
        if ($type == 'register') {
            $stmt->bindParam(':id', $cond, PDO::PARAM_STR);
        } else {
            $stmt->bindParam(':mobile', $cond, PDO::PARAM_STR);
        }
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    public function socialLogin($Req) {
        if (isset($Req['u_id'])) {
            $id = $Req['u_id'];
            $type = $Req['social_type'];
            global $userObj;
            $sql = "INSERT INTO social_login_data
                    SET 
                        data = :data,
                        version_id = :version_id,
                        date_added = :date_added ";
            $stmt = $this->conn->prepare($sql);
            $stmt->bindParam(':data', json_encode($Req), PDO::PARAM_STR);
            $version_id = APP_VERSION;
            $stmt->bindParam(':version_id', $version_id, PDO::PARAM_INT);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
            $stmt->execute();

            $sql = "SELECT 
                        u.user_name, u.email, ua.active, u.mobile, u.dial_code,
                        ua.lat, ua.lon, u.password, ua.code, ua.id, ua.user_id,
                        ua.page_type, ua.date_added, ua.page_id, ua.country_symbol, ua.is_deleted
                    FROM users u 
                    LEFT JOIN user_auth ua ON u.id = ua.user_id
                    WHERE u.user_level = 2 
                    AND (
                        u.$type = :u_id " .
                (trim($Req['email']) ? " OR u.email = :email " : '') .
                (trim($Req['mobile']) ? " OR u.mobile = :mobile" : '') .
                ($Req['id'] ? " OR ua.id = :user_id" : '') .
                ")
                    AND ua.is_deleted = '0' 
                    AND ua.page_type = 'user'
                    ORDER BY 
                        FIELD(u.$type, :u_id) DESC" .
                (trim($Req['email']) ? ", FIELD(u.email, :email) DESC " : '') .
                " LIMIT 1";
            $query = $this->conn->prepare($sql);
            $query->bindParam(':u_id', $id, PDO::PARAM_STR);
            if (trim($Req['email'])) $query->bindParam(':email', $Req['email'], PDO::PARAM_STR);
            if (trim($Req['mobile'])) $query->bindParam(':mobile', $Req['mobile'], PDO::PARAM_STR);
            if ($Req['id']) $query->bindParam(':user_id', $Req['id'], PDO::PARAM_STR);
            $query->execute();
            $signInData = $query->fetch(PDO::FETCH_ASSOC);
            $sql = "INSERT INTO social_login_data
                            SET 
                                data = :data,
                                version_id = :version_id,
                                date_added = :date_added ";
            $stmt = $this->conn->prepare($sql);
            $stmt->bindParam(':data', json_encode($signInData), PDO::PARAM_STR);
            $version_id = APP_VERSION;
            $stmt->bindParam(':version_id', $version_id, PDO::PARAM_STR);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
            $stmt->execute();
            if ($signInData) {
                if ($signInData['active'] == "0") return ['success' => false, 'error' => 'Account_Disabled'];
                elseif ($signInData['is_deleted'] == "0") {
                    $this->updateLastLoging($signInData['id']);
                    if ($signInData['active'] == "3") {
                        $userObj->changeStatuses($signInData['id'], '1', "1");
                        $userObj->changeDeleteDate($signInData['id'], '1');
                        $res = $this->getUserDataByID($signInData['id']);
                        $userObj->changeStatuses($res['Have_page_id'], '1', "1");
                        $userObj->changeDeleteDate($res['Have_page_id'], '1');
                    }
                    $this->Update_Social_Id($signInData['user_id'], $id, $type);
                    return ['data' => $signInData, 'success' => true];
                } else return ['success' => false, 'error' => 'Account_Deleted'];
            } else {
                // $password = password_hash($id, PASSWORD_DEFAULT);
                $id = $this->registerForSocial(
                    '',
                    $Req['first_name'] . ' ' . $Req['last_name'],
                    $Req['u_id'],
                    $Req['social_type'],
                    $Req['email'],
                    $Req['mobile']
                );

                if (is_array($id)) {
                    return $id;
                } else {
                    $Req['id'] = $id;
                    if ($Req['id']) {
                        return $this->socialLogin($Req);
                    }
                }
            }
        } else {
            return ['success' => false, 'error' => 'User_Not_Found'];
        }
    }
    //****************************************** REGISTER ******************************************
    //****************************************** REGISTER ******************************************
    //****************************************** REGISTER ******************************************
    //****************************************** REGISTER ******************************************
    //****************************************** REGISTER ******************************************


    public function checkIfMobileExistForEditing($mobile) {
        $sql = "SELECT u.mobile, ua.id 
                FROM `users` u 
                LEFT JOIN `user_auth` ua ON u.id = ua.user_id AND ua.page_type = 'user'
                WHERE u.`mobile` = :mobile";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':mobile', $mobile, PDO::PARAM_STR);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }

    public function register($Req) {
        $sql = "INSERT INTO users 
                    (mobile, password, user_name,lat,lon,type)
                VALUES 
                    (:mobile, :password, :user_name,:lat,:lon , :type) ";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':mobile', $Req['mobile']);
        $stmt->bindParam(':password', $Req['password']);
        $stmt->bindParam(':lat', $Req['lat']);
        $stmt->bindParam(':lon', $Req['lon']);
        $stmt->bindParam(':type', $Req['type']);
        $username = $Req['first_name'] . ' ' . $Req['last_name'];
        $stmt->bindParam(':user_name', $username);
        $stmt->execute();
        return $this->conn->lastInsertId();
    }

    public function makeAuthCode($id) {
        $token = password_hash($id . "MOSALAHISTHEKING" . $id, PASSWORD_DEFAULT);
        $sql = "UPDATE users
                SET code = :token 
                WHERE id = :id";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':token', $token);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
    }

    //****************************************** FORGET PASS ******************************************
    //****************************************** FORGET PASS ******************************************
    //****************************************** FORGET PASS ******************************************
    //****************************************** FORGET PASS ******************************************
    //****************************************** FORGET PASS ******************************************
    public function check_code($email, $code) {
        $sql = "SELECT * FROM 
        verification
         WHERE `email` = :email AND `code` = :code";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':email', $email, PDO::PARAM_STR);
        $query->bindParam(':code', $code, PDO::PARAM_STR);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }
    public function updatePassword($email, $newPassword, $type) {
        $column = ($type == 1) ? 'email' : 'mobile';
        $sql = "UPDATE users SET `password` = :password WHERE $column = :$column ";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':' . $column, $email, PDO::PARAM_STR);
        $query->bindParam(':password', $newPassword, PDO::PARAM_STR); // Bind the new password parameter
        $query->execute();

        return $query->rowCount() > 0;
    }
    //****************************************** HEADER INFO ******************************************
    //****************************************** HEADER INFO ******************************************
    //****************************************** HEADER INFO ******************************************
    //****************************************** HEADER INFO ******************************************
    //****************************************** HEADER INFO ******************************************

    public function getUserDataByAuth($authentication_code) {
        // Query to retrieve the page_type from user_auth table
        $pageTypeQuery = "SELECT * FROM user_auth WHERE code = :authentication_code";
        $pageTypeStmt = $this->conn->prepare($pageTypeQuery);
        $pageTypeStmt->bindParam(':authentication_code', $authentication_code, PDO::PARAM_STR);
        $pageTypeStmt->execute();
        $pageType = $pageTypeStmt->fetch(PDO::FETCH_ASSOC);

        if ($pageType['page_type'] === 'user') {
            // Query to get user data if page_type is 'user'
            $sql = "SELECT u.*
            FROM users u
            WHERE u.id = '{$pageType['user_id']}'";
        } elseif ($pageType['page_type'] === 'page') {
            $sql = "SELECT
                    u.user_name,
                    u.img,
                    u.id,
                    pf.img AS post_img,
                    pf.video AS post_video,
                    pf.post,
                    IF(EXISTS (
                        SELECT 1
                        FROM subscriptions su
                        WHERE su.user_id = a.id
                        AND '{$this->dateTime}' BETWEEN su.date_from AND su.date_to
                    ), 1, 0) AS is_subs
                FROM user_page_acc u
                JOIN user_auth a ON a.page_id = u.id
                LEFT JOIN post_free pf ON a.id = pf.user_id
                WHERE a.code = :authentication_code
                GROUP BY u.user_name, u.img, u.id, pf.img, pf.video, pf.post
                ";
        } else {
            return false;
        }

        // Execute the main query
        $query = $this->conn->prepare($sql);
        $query->bindParam(':authentication_code', $authentication_code, PDO::PARAM_STR);
        $query->execute();
        $userData = $query->fetch(PDO::FETCH_ASSOC);

        // Merge the user data and page type information
        $mergedData = array_merge($userData, $pageType);
        if ($mergedData) {
            $mergedData['Have_page_id'] = $this->getIdOfPage($pageType['id']) ?: null;
            $mergedData['subscriptions_hide'] = $this->get_subscriptions_hide();
        }

        return $mergedData;
    }
    public function getUserDataByID($id) {
        $pageTypeQuery = "SELECT * FROM user_auth WHERE id = :id";
        $pageTypeStmt = $this->conn->prepare($pageTypeQuery);
        $pageTypeStmt->bindParam(':id', $id, PDO::PARAM_STR);
        $pageTypeStmt->execute();
        $pageType = $pageTypeStmt->fetch(PDO::FETCH_ASSOC);

        if ($pageType['page_type'] === 'user') {
            $sql = "SELECT u.*
            FROM users u
            WHERE u.id = '{$pageType['user_id']}'";
        } elseif ($pageType['page_type'] === 'page') {
            $sql = "SELECT
                        u.user_name AS user_name,
                        u.img,
                        a.id,
                        u.dial_code,
                        u.mobile,
                        u.description,
                        u.services_id AS service_id,
                        a.lat,
                        a.lon,
                        a.user_id,
                        u.address,
                        sl.ser_name AS service_name,
                        pf.img AS post_img,
                        pf.video AS post_video,
                        pf.post,
                        IF(EXISTS (
                            SELECT 1
                            FROM subscriptions su
                            WHERE su.user_id = a.id
                            AND '{$this->dateTime}' BETWEEN su.date_from AND su.date_to
                        ), 1, 0) AS is_subs
                    FROM user_page_acc u
                    JOIN user_auth a ON a.page_id = u.id
                    LEFT JOIN post_free pf ON a.id = pf.user_id
                    LEFT JOIN service_langs sl ON u.services_id = sl.service_id AND sl.lang_code = '" . LANGUAGE . "'
                    WHERE a.id = :id
                    GROUP BY u.user_name, u.img, a.id, u.dial_code, u.mobile, u.description, u.services_id, a.lat, a.lon, u.address, sl.ser_name, pf.img, pf.video, pf.post
                    ";
        } else {
            return false;
        }

        // Execute the main query
        $query = $this->conn->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_STR);
        $query->execute();
        $userData = $query->fetch(PDO::FETCH_ASSOC);
        // Merge the user data and page type information
        $mergedData = array_merge($userData, $pageType);
        if ($pageType['page_type'] === 'page') {
            $sql = "SELECT user_id FROM user_auth WHERE id = :id";
            $query = $this->conn->prepare($sql);
            $query->bindParam(':id', $userData['user_id'], PDO::PARAM_STR);
            $query->execute();
            $user_id = $query->fetchColumn(0);
            $sql = "SELECT password FROM users WHERE id = :id";
            $query = $this->conn->prepare($sql);
            $query->bindParam(':id', $user_id, PDO::PARAM_STR);
            $query->execute();
            $mergedData['password'] = $query->fetchColumn(0);
        }
        if ($mergedData) {
            $mergedData['Have_page_id'] = $this->getIdOfPage($id) ?: null;
            if ($mergedData['Have_page_id'] == null && $pageType['page_type'] === 'page') {
                $mergedData['Have_page_id'] = $id;
            }
            $mergedData['subscriptions_hide'] = $this->get_subscriptions_hide();
        }
        return $mergedData;
    }

    public function getIdOfPage($id) {
        $sql = "SELECT id FROM user_auth WHERE page_type = 'page' AND user_id = :id AND is_deleted = '0' AND active != '0'";
        $query = $this->conn->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_STR);
        $query->execute();
        return $query->fetchColumn(0);
    }
    public function get_subscriptions_hide() {
        $sql = "SELECT `value` FROM settings WHERE name = 'subscriptions_hide'";
        $query = $this->conn->prepare($sql);
        $query->execute();
        return $query->fetchColumn(0);
    }
    //****************************************** socialLogin ******************************************
    //****************************************** socialLogin ******************************************
    //****************************************** socialLogin ******************************************
    //****************************************** socialLogin ******************************************
    //****************************************** socialLogin ******************************************

    public function Update_Social_Id($id, $social_id, $type) {
        $sql = "UPDATE `users` SET $type = :social_id WHERE `id` = :id";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':social_id', $social_id, PDO::PARAM_STR);
        $stmt->execute();
    }


    public function registerForSocial($password, $full_name, $social_id, $type, $email, $mobile) {
        $connection = $this->conn; // الحصول على اتصال واحد

        // Insert into users table
        $sql = "INSERT INTO `users` ($type, password, mobile, user_name, email) VALUES (:social_id, :password, :mobile, :full_name, :email)";
        $stmt = $connection->prepare($sql);
        $stmt->bindParam(':password', $password);
        $stmt->bindParam(':full_name', trim($full_name));
        $stmt->bindParam(':mobile', $mobile);
        $stmt->bindParam(':social_id', $social_id);
        $stmt->bindParam(':email', $email);
        $stmt->execute();
        $user_id = $connection->lastInsertId(); // استخدام نفس الاتصال للحصول على آخر معرف

        if ($user_id) {
            return $this->AddUserAuth($user_id); // تمرير نفس الاتصال
        } else {
            return ['success' => false, 'error' => 'User_Not_Added'];
        }
    }

    // public function AddUserAuth($user_id) {
    //     $connection = $this->conn; // الحصول على اتصال واحد
    //     // Insert into user_auth table
    //     $sqlAuth = "INSERT INTO `user_auth` (page_id, user_id, page_type, date_added) VALUES (:page_id, :user_id, :page_type, :date_added)";
    //     $stmt = $connection->prepare($sqlAuth);
    //     $page_id = 0; // Assuming default page_id
    //     $page_type = 'user'; // Assuming default page_type
    //     $stmt->bindParam(':page_id', $page_id);
    //     $stmt->bindParam(':user_id', $user_id);
    //     $stmt->bindParam(':page_type', $page_type);
    //     $stmt->bindParam(':date_added', $this->dateTime);
    //     $stmt->execute();
    //     $auth_id = $connection->lastInsertId(); // استخدام نفس الاتصال للحصول على آخر معرف
    //     $this->makeAuthCode($user_id);
    //     return $auth_id;
    // }



    //****************************************** SendSMS ******************************************
    //****************************************** SendSMS ******************************************
    //****************************************** SendSMS ******************************************
    //****************************************** SendSMS ******************************************
    //****************************************** SendSMS ******************************************
    public function SendSMS($Req, $otp) {
        $environment = 2; // 1 لـ Live، 2 لـ Test
        $username = '58048f0d-ca50-44c5-9fa6-3e065d256709'; // الحصول على الاسم من الإعدادات
        $password = 'c1444d553ecaf8ebc706025f72acfee2bad7b61fda1ba5b9f8e4de9b6f0e1688'; // الحصول على كلمة المرور من الإعدادات
        $sender = "b611afb996655a94c8e942a823f1421de42bf8335d24ba1f84c437b2ab11ca27"; // Sender ID للتجربة
        $template = 'e83faf6025ec41d0f40256d2812629f5fa9291d05c8322f31eea834302501da8'; // معرف التيمبلت المخصص الجديد
        // إعداد الـ URL وبيانات POST
        $url = "https://smsmisr.com/api/OTP/";
        $data = [
            'environment' => $environment,
            'username' => $username,
            'password' => $password,
            'sender' => $sender,
            'mobile' => $Req['dial_code'] . $Req['mobile'],
            'template' => $template,
            'otp' => $otp
        ];
        // إرسال الطلب باستخدام cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);
        $response = json_decode($response, true);
        return $response;
    }
}
